﻿DeclareModule Visual
Declare Create()
Declare Free(*This)
EndDeclareModule

Module Visual

UseModule AIMP
UseModule Unknown

Structure Visual Extends UnkSctuct
  
EndStructure

EnableExplicit


Procedure GetFlags(*This.Visual)
  ProcedureReturn #AIMP_VISUAL_FLAGS_RQD_DATA_SPECTRUM | #AIMP_VISUAL_FLAGS_RQD_DATA_WAVE
EndProcedure

Procedure Draw(*This.Visual, *Data.TAIMPVisualData)
  Share::SetShare(*Data)
EndProcedure

Procedure Create()
  Protected *Struct.Visual
  
  *Struct = AllocateMemory(SizeOf(Visual))
  If *Struct
    InitializeStructure(*Struct, Visual)
    CopyMemory(AIMP::?IID_IAIMPExtensionCustomVisualization, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Proc
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Proc:
    Unknown::UnkProc
    Data.i @GetFlags()
    Data.i @Draw()
  EndDataSection
EndProcedure

Procedure Free(*This.Visual)
  Protected Res = #False
  
  If *This
    ClearStructure(*This, Visual)
    FreeMemory(*This)
    Res = #True
  EndIf
  
  ProcedureReturn Res
EndProcedure

EndModule
; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP